#include <PalmOS.h>

#include "HostPalm.h"
#include <VFSMgr.h>
#include "endianutils.h"

#include "AdnDebugMgr.h"
//#include "PACEInterfaceLib.h"
#include <PCENativeCall.h>
#include <size_t.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <float.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <file_struc.h>
#include <console_io.h>
#include <dirent.h>
#include <unistd.h>
//#include <TapWave.h>

struct TwGlue*   twGlue;

// Linker still looks for ARMlet_Main as entry point, but the
// "ARMlet" name is now officially discouraged.  Compare an
// contrast to "PilotMain" for 68K applications.
#define PNO_Main ARMlet_Main

// Define DEBUG as 0 to turn off debugging support in the PNO.
// With this on, the PNO will register itself with the Palm OS
// Debugger on startup, allowing stepping through the code.
#define DEBUG 1

//  Define MEMORY_DEBUG as 1 to turn on SD card logging of all malloc
//	or free calls to find leaking memory.
#define MEMORY_DEBUG 0

// Original stationery application but using library interface
// rather than class-derived interface.

/*
 * The following functions provide malloc/free support to Metrowerks
 * Standard Library (MSL). This feature requires the MSL library be
 * built with _MSL_OS_DIRECT_MALLOC enabled.
 */
UInt32 *host_event_handler;
UInt32 *host_keyboard_handler;
UInt32 *host_event;
void    (*irhandler) (void);
extern void MameAppStop();


void TwUndef()
{
	#undef DbgBreak
    #undef DbgMessage

    #undef DmArchiveRecord
    #undef DmAttachRecord
    #undef DmAttachResource
    #undef DmCloseDatabase
    #undef DmCreateDatabase
    #undef DmCreateDatabaseFromImage
    #undef DmDatabaseInfo
    #undef DmDatabaseSize
    #undef DmDeleteDatabase
    #undef DmDeleteRecord
    #undef DmDetachRecord
    #undef DmDetachResource
    #undef DmFindDatabase
    #undef DmFindRecordByID
    #undef DmFindResource
    #undef DmFindResourceType
    #undef DmFindSortPosition
    #undef DmGet1Resource
    #undef DmGetAppInfoH
    #undef DmGetDatabase
    #undef DmGetLastErr
    #undef DmGetNextDatabaseByTypeCreator
    #undef DmGetRecord
    #undef DmGetResource
    #undef DmGetResourceIndex
    #undef DmInsertionSort
    #undef DmMoveCategory
    #undef DmMoveRecord
    #undef DmNewHandle
    #undef DmNewRecord
    #undef DmNewResource
    #undef DmNumDatabases
    #undef DmNumRecords
    #undef DmNumRecordsInCategory
    #undef DmNumResources
    #undef DmOpenDatabase
    #undef DmOpenDatabaseByTypeCreator
    #undef DmOpenDatabaseInfo
    #undef DmPositionInCategory
    #undef DmQueryNextInCategory
    #undef DmQueryRecord
    #undef DmQuickSort
    #undef DmRecordInfo
    #undef DmReleaseRecord
    #undef DmReleaseResource
    #undef DmRemoveRecord
    #undef DmRemoveResource
    #undef DmRemoveSecretRecords
    #undef DmResetRecordStates
    #undef DmResizeRecord
    #undef DmResizeResource
    #undef DmResourceInfo
    #undef DmSearchRecord
    #undef DmSearchResource
    #undef DmSeekRecordInCategory
    #undef DmSet
    #undef DmSetDatabaseInfo
    #undef DmSetRecordInfo
    #undef DmSetResourceInfo
    #undef DmStrCopy
    #undef DmWrite
    #undef DmWriteCheck

    #undef ErrDisplayFileLineMsg

    #undef EvtAddEventToQueue
    #undef EvtDequeuePenPoint
    #undef EvtEventAvail
    #undef EvtGetEvent
    #undef EvtGetPen
    #undef EvtResetAutoOffTimer
    #undef EvtSetAutoOffTimer

    #undef ExgConnect
    #undef ExgPut
    #undef ExgGet
    #undef ExgAccept
    #undef ExgDisconnect
    #undef ExgSend
    #undef ExgReceive
    #undef ExgControl
    #undef ExgRegisterData
    #undef ExgRegisterDatatype
    #undef ExgNotifyReceive
    #undef ExgNotifyGoto
    #undef ExgDBRead
    #undef ExgDBWrite
    #undef ExgDoDialog
    #undef ExgRequest
    #undef ExgSetDefaultApplication
    #undef ExgGetDefaultApplication
    #undef ExgGetTargetApplication
    #undef ExgGetRegisteredApplications
    #undef ExgGetRegisteredTypes
    #undef ExgNotifyPreview

    #undef ExpCardInfo
    #undef ExpCardInserted
    #undef ExpCardPresent
    #undef ExpCardRemoved
    #undef ExpSlotEnumerate

    #undef FntAverageCharWidth
    #undef FntBaseLine
    #undef FntCharHeight
    #undef FntCharWidth
    #undef FntCharsInWidth
    #undef FntCharsWidth
    #undef FntDefineFont
    #undef FntDescenderHeight
    #undef FntGetFont
    #undef FntGetFontPtr
    #undef FntGetScrollValues
    #undef FntLineHeight
    #undef FntLineWidth
    #undef FntSetFont
    #undef FntWCharWidth
    #undef FntWidthToOffset
    #undef FntWordWrap
    #undef FntWordWrapReverseNLines

    #undef FrmDispatchEvent
    #undef MenuHandleEvent

    #undef FtrGet
    #undef FtrPtrFree
    #undef FtrPtrNew
    #undef FtrPtrResize
    #undef FtrSet
    #undef FtrUnregister

    #undef KeyCurrentState
    #undef KeySetMask

    #undef MemCmp
    #undef MemMove
    #undef MemSet

    #undef MemHandleFree
    #undef MemHandleLock
    #undef MemHandleNew
    #undef MemHandleResize
    #undef MemHandleSize
    #undef MemHandleUnlock

    #undef MemPtrFree
    #undef MemPtrNew
    #undef MemPtrResize
    #undef MemPtrSize

    #undef PrefGetAppPreferences
    #undef PrefGetPreference
    #undef PrefSetAppPreferences
    #undef PrefSetPreference

    #undef SndSetDefaultVolume
    #undef SndGetDefaultVolume

    #undef SndPlayResource

    #undef SndStreamCreate
    #undef SndStreamDelete
    #undef SndStreamGetPan
    #undef SndStreamGetVolume
    #undef SndStreamPause
    #undef SndStreamSetPan
    #undef SndStreamSetVolume
    #undef SndStreamStart
    #undef SndStreamStop

    #undef SysHandleEvent

    #undef SysNotifyBroadcast
    #undef SysNotifyBroadcastDeferred
    #undef SysNotifyRegister
    #undef SysNotifyUnregister

    #undef SysTaskDelay

    #undef SysUIAppSwitch

    #undef TimGetSeconds
    #undef TimGetTicks

    #undef StrCopy
    #undef StrNCopy
    #undef StrCat
    #undef StrNCat
    #undef StrLen
    #undef StrCompareAscii
    #undef StrCompare
    #undef StrNCompareAscii
    #undef StrNCompare
    #undef StrCaselessCompare
    #undef StrNCaselessCompare
    #undef StrToLower
    #undef StrIToA
    #undef StrIToH
    #undef StrLocalizeNumber
    #undef StrDelocalizeNumber
    #undef StrChr
    #undef StrStr
    #undef StrAToI
    #undef StrPrintF
    #undef StrVPrintF

    #undef TxtByteAttr
    #undef TxtCaselessCompare
    #undef TxtCharAttr
    #undef TxtCharBounds
    #undef TxtCharEncoding
    #undef TxtCharIsValid
    #undef TxtCharSize
    #undef TxtCharWidth
    #undef TxtCharXAttr
    #undef TxtCompare
    #undef TxtConvertEncoding
    #undef TxtEncodingName
    #undef TxtFindString
    #undef TxtGetChar
    #undef TxtGetNextChar
    #undef TxtGetPreviousChar
    #undef TxtGetTruncationOffset
    #undef TxtGetWordWrapOffset
    #undef TxtMaxEncoding
    #undef TxtNameToEncoding
    #undef TxtParamString
    #undef TxtReplaceStr
    #undef TxtSetNextChar
    #undef TxtStrEncoding
    #undef TxtTransliterate
    #undef TxtWordBounds

    #undef VFSCustomControl
    #undef VFSDirCreate
    #undef VFSDirEntryEnumerate
    #undef VFSExportDatabaseToFile
    #undef VFSExportDatabaseToFileCustom
    #undef VFSFileClose
    #undef VFSFileCreate
    #undef VFSFileDelete
    #undef VFSFileEOF
    #undef VFSFileGetAttributes
    #undef VFSFileGetDate
    #undef VFSFileOpen
    #undef VFSFileRead
    #undef VFSFileReadData
    #undef VFSFileRename
    #undef VFSFileResize
    #undef VFSFileSeek
    #undef VFSFileSetAttributes
    #undef VFSFileSetDate
    #undef VFSFileSize
    #undef VFSFileTell
    #undef VFSFileWrite
    #undef VFSGetDefaultDirectory
    #undef VFSImportDatabaseFromFile
    #undef VFSImportDatabaseFromFileCustom
    #undef VFSInstallFSLib
    #undef VFSRegisterDefaultDirectory
    #undef VFSRemoveFSLib
    #undef VFSUnregisterDefaultDirectory
    #undef VFSVolumeEnumerate
    #undef VFSVolumeFormat
    #undef VFSVolumeGetLabel
    #undef VFSVolumeInfo
    #undef VFSVolumeMount
    #undef VFSVolumeSetLabel
    #undef VFSVolumeSize
    #undef VFSVolumeUnmount

    #undef WinClipRectangle
    #undef WinCopyRectangle

    #undef WinCreateOffscreenWindow
    #undef WinCreateWindow
    #undef WinDeleteWindow

    #undef WinDisableWindow
    #undef WinEnableWindow

    #undef WinGetBounds
    #undef WinSetBounds

    #undef WinGetPixel
    #undef WinGetPixelRGB

    #undef WinGetFramesRectangle
    #undef WinGetSupportedDensity
    #undef WinGetWindowFrameRect

    #undef WinPaintBitmap
    #undef WinPaintChar
    #undef WinPaintChars
    #undef WinPaintLine
    #undef WinPaintLines
    #undef WinPaintPixel
    #undef WinPaintPixels
    #undef WinPaintRectangle
    #undef WinPaintRectangleFrame
    #undef WinPaintRoundedRectangleFrame

    #undef WinPushDrawState
    #undef WinPopDrawState

    #undef WinRestoreBits
    #undef WinSaveBits

    #undef WinScreenGetAttribute
    #undef WinScreenMode

    #undef WinScreenLock
    #undef WinScreenUnlock

    #undef WinScrollRectangle

    #undef WinIndexToRGB
    #undef WinRGBToIndex

    #undef WinGetDisplayWindow

    #undef WinGetActiveWindow
    #undef WinSetActiveWindow

    #undef WinGetDrawWindow
    #undef WinSetDrawWindow

    #undef WinGetClip
    #undef WinSetClip
    #undef WinResetClip

    #undef WinGetCoordinateSystem
    #undef WinSetCoordinateSystem

    #undef WinSetBackColor
    #undef WinSetBackColorRGB

    #undef WinSetForeColor
    #undef WinSetForeColorRGB

    #undef WinSetTextColor
    #undef WinSetTextColorRGB

    #undef WinSetDrawMode
    #undef WinSetUnderlineMode

    #undef WinSetPattern
    #undef WinSetPatternType

    #undef WinScaleCoord
    #undef WinUnscaleCoord

    #undef WinScalePoint
    #undef WinUnscalePoint

    #undef WinScaleRectangle
    #undef WinUnscaleRectangle

    #undef WinDisplayToWindowPt
    #undef WinWindowToDisplayPt

    #undef WinGetBitmapDimensions

    #undef PINGetInputAreaState
    #undef PINSetInputAreaState
    #undef PINGetInputTriggerState
    #undef PINSetInputTriggerState

    #undef StatHide
    #undef StatShow
    #undef StatGetAttribute

    #undef SysGetOrientation
    #undef SysSetOrientation
    #undef SysGetOrientationTriggerState
    #undef SysSetOrientationTriggerState

   
    #undef BtLibOpen
    #undef BtLibClose
    #undef BtLibHandleEvent

    #undef BtLibRegisterManagementNotification
    #undef BtLibUnregisterManagementNotification
    #undef BtLibStartInquiry
    #undef BtLibCancelInquiry
    #undef BtLibDiscoverSingleDevice
    #undef BtLibDiscoverMultipleDevices
    #undef BtLibGetSelectedDevices
    #undef BtLibGetRemoteDeviceName
    #undef BtLibLinkConnect
    #undef BtLibLinkDisconnect
    #undef BtLibPiconetCreate
    #undef BtLibPiconetDestroy
    #undef BtLibPiconetUnlockInbound
    #undef BtLibPiconetLockInbound
    #undef BtLibLinkSetState
    #undef BtLibLinkGetState
    #undef BtLibSetGeneralPreference
    #undef BtLibGetGeneralPreference

    #undef BtLibSocketCreate
    #undef BtLibSocketClose
    #undef BtLibSocketListen
    #undef BtLibSocketConnect
    #undef BtLibSocketRespondToConnection
    #undef BtLibSocketSend
    #undef BtLibSocketAdvanceCredit
    #undef BtLibSocketGetInfo

    #undef BtLibSdpGetServerChannelByUuid
    #undef BtLibSdpGetPsmByUuid
    #undef BtLibSdpServiceRecordCreate
    #undef BtLibSdpServiceRecordDestroy
    #undef BtLibSdpServiceRecordStartAdvertising
    #undef BtLibSdpServiceRecordStopAdvertising
    #undef BtLibSdpServiceRecordSetAttributesForSocket
    #undef BtLibSdpServiceRecordsGetByServiceClass
    #undef BtLibSdpServiceRecordMapRemote
    #undef BtLibSdpServiceRecordGetStringOrUrlLength
    #undef BtLibSdpServiceRecordGetNumListEntries
    #undef BtLibSdpServiceRecordGetNumLists
    #undef BtLibSdpCompareUuids

    #undef BtLibSecurityFindTrustedDeviceRecord
    #undef BtLibSecurityRemoveTrustedDeviceRecord
    #undef BtLibSecurityGetTrustedDeviceRecordInfo
    #undef BtLibSecurityNumTrustedDeviceRecords
    #undef BtLibAddrBtdToA
    #undef BtLibAddrAToBtd

    #undef BtLibServiceOpen
    #undef BtLibServiceClose
    #undef BtLibServiceIndicateSessionStart
    #undef BtLibServicePlaySound

    #undef TimSecondsToDateTime
    #undef TimDateTimeToSeconds

   
    #undef NetInit
    #undef NetFini

    #undef accept
    #undef bind
    #undef closesocket
    #undef connect
    #undef getpeername
    #undef getsockname
    #undef getsockopt
    #undef listen
    #undef poll
    #undef recv
    #undef recvfrom
    #undef send
    #undef sendto
    #undef setsockopt
    #undef shutdown
    #undef socket

    #undef gethostbyname
    #undef gethostbyaddr

    #undef inet_aton
    #undef inet_ntoa

    #undef SysBatteryInfo
    #undef SysGetROMToken


    #undef SndStreamCreateExtended
    #undef SndStreamDeviceControl

    #undef PceNativeCall

    
    #undef FrmAlert
    #undef FrmCustomAlert

    #undef Calloc
    #undef Malloc
    #undef Realloc
    #undef Strdup
    #undef Free

    #undef dprintf
   
    #undef ClipboardAddItem
    #undef ClipboardAppendItem
    #undef ClipboardGetItem

    #undef FontSelect

    #undef FrmCustomResponseAlert
    #undef FrmGetActiveForm
    #undef FrmGetWindowHandle

    #undef TimeZoneToAscii

    #undef AlmGetAlarm
    #undef AlmSetAlarm

    #undef DateTemplateToAscii
    #undef DateToAscii

    #undef EvtAddUniqueEventToQueue
    #undef EvtGetPenNative

    #undef MemHeapCheck
    #undef MemHeapFreeBytes
    #undef MemHeapSize
    #undef MemHeapCompact
    #undef MemHeapScramble

    #undef MemDebugMode
    #undef MemSetDebugMode

    #undef MemHandleOwner
    #undef MemHandleSetOwner

    #undef MemPtrOwner
    #undef MemPtrSetOwner

    #undef SndDoCmd
    #undef SndPlaySmf
    #undef SndPlaySmfResource

    #undef SysAppLaunch

    #undef SysErrString

    #undef SysCurAppDatabase

    #undef SysGetStackInfo

    #undef SysStringByIndex

    #undef TimeToAscii
    #undef TimTimeZoneToUTC
    #undef TimUTCToTimeZone

#if TAPWAVE_API_VERSION >= 0x0203
    #undef SysLoadModule
    #undef SysUnloadModule
    #undef SysGetEntryAddresses

    
#endif // TAPWAVE_API_VERSION >= 0x0203

#define			MemPtrFree(	p) \
						MemChunkFree(p)
}

void	*my_emulStateP;
Call68KFuncType	*my_call68KFuncP;

static void relocate(struct TwGlue* twGlue)
{
    Int8* base = (Int8*) __ARMlet_Startup__;
    Int32 size = MemPtrSize(base);
    Int32* end = (Int32*)(base + size - 4);
    Int32* cur = end - (*end);

    for (; cur < end; cur++) {
        *(long*)(base + *cur) += (Int32)base;
    }
}


void *MemGluePtrNewL ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = ByteSwap32 ( foo );

  r = my_call68KFuncP ( my_emulStateP,
			(UInt32)host_event_handler  , &arg, 4 );

  if ((UInt8*) (r) == 0)
  {
  		WinSetCoordinateSystem(kCoordinatesStandard);
  		FrmCustomAlert(10024,"Out of Memory","","");
  		WinSetCoordinateSystem(kCoordinatesNative);
  }
	
  return ( (UInt8*) (r) );
}

void CallEvent(void)
{

	my_call68KFuncP ( my_emulStateP,
			(UInt32)host_event  , NULL, 0 );
}

 
/*
 * The following functions provide MemGluePtrNewL/free support to Metrowerks
 * Standard Library (MSL). This feature requires the MSL library be
 * built with _MSL_OS_DIRECT_MALLOC enabled.
 */
 
 // constants for TwGetSlotNumberForVolume()
#define twSlotUnknown           -1
#define twSlotInternal          0
#define twSlotLeft              1
#define twSlotRight             2

// constants for TwGet{PRC|DB}DataDirectory
#define kTwDirectoryPrefix      "/PALM/Programs/"
#define kTwPathNameResType      'Twdp'
#define kTwPathNameResID        0

#if MEMORY_DEBUG
typedef struct memmalloc
{
	unsigned int	mem;
	int	size;
}memmalloc;

static memmalloc mmX[4096];

static void malloc_debug_init(void)
{
	memset(mmX, 0, sizeof(mmX));
}

static void malloc_debug_status(int flag)
{
	char buf[80];
	int total = 0;
	int items = 0;
	int i;
	for (i=0; i<4096; i++)
	{
		if (mmX[i].mem)
		{
			total += mmX[i].size;
			items++;
			if (flag)
			{
				sprintf(buf,"memory: %d size: %d\n", mmX[i].mem, mmX[i].size);
				debugs(buf);
			}
		}
	}
	sprintf (buf,"malloc() total %d in %d items\n", total, items);
	debugs(buf);
}

static void malloc_mmX(unsigned int addr, int size)
{
	int i;
	for (i=0; i<4096; i++)
	{
		if (mmX[i].mem) continue;
		mmX[i].mem = addr;
		mmX[i].size = size;
		break;
	}
}

static int free_mmX(unsigned int addr)
{
	int i;
	int size;
	for (i=0; i<4096; i++)
	{
		if (mmX[i].mem != addr) continue;
		size = mmX[i].size;
		mmX[i].mem = 0;
		mmX[i].size = 0;
		return 1;
	}
	printf("ERROR: Could not find address: %d\n", addr);
	return 1;
}
#endif
void*
__sys_alloc(size_t size)
{
    //ErrFatalDisplayIf(ptr == NULL, "out of memory");
    void * ptr = MemGluePtrNewL(size);

#if MEMORY_DEBUG
	malloc_mmX((int)ptr, size);
#endif

    return ptr;
}


void
__sys_free(void* ptr)
{
	
#if MEMORY_DEBUG
	free_mmX((int)ptr);
#endif
    (void) MemPtrFree(ptr);
}

size_t
__sys_pointer_size(void* ptr)
{
    return (size_t) MemPtrSize(ptr);
}

/*
 * This function converts stanard windows path into palmos path.
 */
int GetSlotNumberForVolume(int volume)
{
	if (volume == 2)
		return 1;
	else if (volume == 3)
		return 2;
	else if (volume == 1)
		return 0;

}

Err GetDBDataDirectory(MemHandle dbH, UInt16 *volRefNumP, Char *pathNameP, UInt16 maxLen)
{
	
}
 
int __sys_path(const char* path, char* buffer, size_t length)
{
    UInt16 volume;

    if (path[1] == ':') {
        // absolute path
        // convert drive letter to slot number, ref ascii table.
        int slot = (path[0] & 0x1F);
        if (slot == 3) {
            slot = twSlotInternal;
        }
        // iterate all volumes
        UInt32 it = vfsIteratorStart;
        while (!VFSVolumeEnumerate(&volume, &it)) {
            if (slot == GetSlotNumberForVolume(volume)) {
                if (strlen(path) < length) {
                    strcpy(buffer, path + 2);
                    goto done;
                }
                break;
            }
        }
    } 
    else 
    {
        // relative path
        // find application data volume and directory
        //if (!TwGetDBDataDirectory(NULL, &volume, buffer, length)) 
        volume = palm_vfs_vol();
        if (!StrStr(path,PALMOPENDIR))
        	strcpy(buffer,PALMOPENDIR);
        //{
            if (path[0] == '/' || path[0] == '\\') 
            {
                buffer[0] = 0;
            }
            if (strlen(buffer) + 1 + strlen(path) < length) 
            {
                strcat(buffer, "/");
                strcat(buffer, path);
                goto done;
            }
        //}
    }
    return -1;
 done:
    for (int i = 0; buffer[i] != 0; i++) {
        if (buffer[i] == '\\') {
            buffer[i] = '/';
        }
    }
    return volume;
}

/*
 * The following functions provide hooks for stdin/stdout/stderr.
 * Applications may override them to do whatever they want. The
 * default implementation redirects console IO through ARM semihosting
 * interface.
 */
int
__close_console(__file_handle file)
{
    return __no_io_error;
}

int
__read_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __io_EOF;
}

int
__write_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __no_io_error;
}

/*
 * The following functions provide basic support for non-console stdio.
 */
int
__open_file(const char * path, __file_modes mode, __file_handle * handle)
{
    char buffer[256];
    int volume = __sys_path(path, buffer, sizeof(buffer));
    UInt16 vfsmode = 0;
    Err err;
    
    if (mode.open_mode == __create_if_necessary) {
        vfsmode |= vfsModeCreate;
    } else if (mode.open_mode == __create_or_truncate) {
        vfsmode |= vfsModeCreate | vfsModeTruncate;
    }
    if (mode.io_mode & __read) {
        vfsmode |= vfsModeRead;
    } else if (mode.io_mode & __write) {
        vfsmode |= vfsModeWrite;
    }
    err = VFSFileOpen(volume, buffer, vfsmode, handle);
    return (err ? __io_error : __no_io_error);
}

int
__close_file(__file_handle file)
{
    Err err = VFSFileClose((FileRef) file);
    return (err ? __io_error : __no_io_error);
}

int
__read_file(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    Err err = VFSFileRead((FileRef) file, *count, buff, count);
    return (*count ? __no_io_error : (err == vfsErrFileEOF ? __io_EOF : __io_error));
}

int
__write_file(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    Err err = VFSFileWrite((FileRef) file, *count, buff, count);
    return (err ? __io_error : __no_io_error);
}

int
__position_file(__file_handle file, fpos_t * position, int mode, __ref_con ref_con)
{
    Err err = VFSFileSeek((FileRef) file, (FileOrigin) mode, (Int32) *position);
    if (err == errNone || err == vfsErrFileEOF) {
        err = VFSFileTell((FileRef) file, position);
    }
    return (err ? __io_error : __no_io_error);
}

int
__delete_file(const char * name)
{
    char buffer[256];
    int volume = __sys_path(name, buffer, sizeof(buffer));
    return (VFSFileDelete(volume, buffer) ? __io_error : __no_io_error);
}

int
__rename_file(const char * src, const char * dst)
{
    char srcbuf[256];
    int srcvol = __sys_path(src, srcbuf, sizeof(srcbuf));
    char dstbuf[256];
    int dstvol = __sys_path(dst, dstbuf, sizeof(dstbuf));
    if (srcvol == dstvol && !VFSFileRename(srcvol, srcbuf, dstbuf)) {
        return __no_io_error;
    }
    return __io_error;
}

/*
 * The following function provide common unix system call interface.
 */
int open(const char *path, int flags, ...)
{
    __file_handle fd = -1;
    __file_modes mod = {0};
    if (flags & O_RDONLY) mod.io_mode = __read;
    if (flags & O_WRONLY) mod.io_mode = __write;
    if (flags & O_RDWR  ) mod.io_mode = __read_write;
    if (flags & O_APPEND) mod.io_mode = __append;
    __open_file(path, mod, &fd);
    return (int) fd;
}

int close(int fd)
{
    Err err = VFSFileClose((FileRef) fd);
    return (err ? -1 : 0);
}

int read(int fd, void* buf, size_t len)
{
    Err err = VFSFileRead((FileRef) fd, len, buf, &len);
    return (len > 0) ? len : (err ? -1 : 0);
}

int write(int fd, void* buf, size_t len)
{
    Err err = VFSFileWrite((FileRef) fd, len, buf, &len);
    return (len > 0) ? len : (err ? -1 : 0);
}

long lseek(int fd, long offset, int whence)
{
    VFSFileSeek((FileRef) fd, (FileOrigin) whence, offset);
    return VFSFileTell((FileRef) fd, (UInt32*)&offset) ? -1 : offset;
}

int chsize(int fd, long size)
{
    return VFSFileResize((FileRef) fd, size) ? -1 : 0;
}

int fstat(int fd, struct stat * buf)
{
    memset(buf, 0, sizeof(*buf));
    VFSFileGetDate((FileRef) fd, vfsFileDateModified, (UInt32*)&buf->st_mtime);
    buf->st_mtime -= 2082844800;
    return VFSFileSize((FileRef) fd, (UInt32*)&buf->st_size) ? -1 : 0;
}
int stat(const char  *path, struct stat * buf)
{
	FILE *temp=fopen(path,"rb");
	return fstat(0,&buf);
	 	
}

int access(const char *path, int mode)
{
    char buffer[256];
    int volume = __sys_path(path, buffer, sizeof(buffer));
    FileRef f;

    if (!VFSFileOpen(volume, buffer, (mode == W_OK ? vfsModeWrite : vfsModeRead), &f)) {
        VFSFileClose(f);
        return 0;
    }

    return -1;
}

int mkdir(const char *path, ...)
{
    char buffer[256];
    int volume = __sys_path(path, buffer, sizeof(buffer));
    return VFSDirCreate(volume, buffer) ? -1 : 0;
}

int rmdir(const char* path)
{
    char buffer[256];
    int volume = __sys_path(path, buffer, sizeof(buffer));
    return VFSFileDelete(volume, buffer) ? -1 : 0;
}

/*void abort(void)
{
    ErrDisplayFileLineMsg(__FILE__, 0, "abort");
}*/

void exit(int status)
{
    ErrDisplayFileLineMsg(__FILE__, status, "Installation Error - File not Found");
}

/*
 * The following functions provide simple time support to MSL.
 */
time_t
__get_time(void)
{
    // Convert epoch 1904-01-01 to 1970-01-01
    return TimGetSeconds() - 2082844800;
}

int
__to_gm_time(time_t* time)
{
    // Convert local time to utc time
    *time -= (PrefGetPreference(prefTimeZone) + PrefGetPreference(prefDaylightSavingAdjustment)) * 60;
    return 1;
}

int
__isdst(void)
{
    // Check if we in day light saving time currently.
    return PrefGetPreference(prefDaylightSavingAdjustment) != 0;
}

struct DIR
{
    struct dirent   _d__dirent;
    UInt32          _d__ref;        /* new style FSRef of directory to iterate */
    UInt32          _d__iterator;   /* new style directory iterator reference */
    FileInfoType    _d__f_info;
};

DIR* opendir (const char * path)
{
    char buf[256];
    int volume = __sys_path(path, buf, sizeof(buf));
    DIR * dir = NULL;
    FileRef dirRef;

    if (errNone == VFSFileOpen(volume, buf, vfsModeRead, &dirRef)) {
        dir = (DIR*) malloc(sizeof(DIR));
        if (NULL != dir) {
            dir->_d__ref = dirRef;
            dir->_d__iterator = vfsIteratorStart;
            dir->_d__f_info.nameBufLen = sizeof(dir->_d__dirent.d_name);
            dir->_d__f_info.nameP = dir->_d__dirent.d_name;
        }
    }
    
    return dir;
}

int closedir(DIR * dir)
{
    int res = -1;

    if (dir) {
        res = VFSFileClose(dir->_d__ref) ? -1 : 0;
        free(dir);
    }
    
    return res;
}

struct dirent* readdir(DIR * dir)
{
    if (VFSDirEntryEnumerate(dir->_d__ref, &dir->_d__iterator, &dir->_d__f_info)) {
        return (struct dirent*) NULL;
    }

    return &dir->_d__dirent;
}


/*******************************
//	AK - adding IR Keyboard, etc support
*/


#define KEY_A     		0x00000001
#define KEY_B	  		0x00000002
#define KEY_START 		0x00000004
#define KEY_SELECT		0x00000008
#define KEY_UP    		0x00000010
#define KEY_DOWN  		0x00000020
#define KEY_LEFT  		0x00000040
#define KEY_RIGHT 		0x00000080
#define KEY_SEL   		0x00000100
#define KEY_QUICKLOAD   0x00000200
#define KEY_QUICKSAVE   0x00000400
#define KEY_TURBO  		0x00000800
#define KEY_SCREENMODE	0x00001000
#define KEY_FRAMESKIP	0x00002000


UInt32 g_bt_gamepadused=0;
UInt32 g_bt_gamepadclosed=0;
UInt32 g_n_serportid=0;
UInt32 g_ir_keyboardused=0;
UInt8 g_ir_confinput[128];
unsigned int g_confinput_treo[20][3];
unsigned int g_confinput[20];


UInt32 stub_SrmSend(UInt16 portId, const void *bufP, UInt32 count, Err *errP)
{
	UInt32 arg[2];
	hostcall_t data;
	UInt32 r;
	data.a = ByteSwap32((UInt32)portId);
	data.b = ByteSwap32((UInt32)bufP);
	data.c = ByteSwap32((UInt32)count);
	data.d = ByteSwap32((UInt32)errP);
	arg[0] = BRIDGE_SrmSend;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	r = my_call68KFuncP ( my_emulStateP,(UInt32)host_keyboard_handler, &(arg[0]), 8 );
	*errP = ByteSwap16((UInt16)(*errP));
	return r;
}

UInt32 stub_SrmReceive(UInt16 portId, void *rcvBufP, UInt32 count, Int32 timeout, Err *errP)
{
	UInt32 arg[2];
	bighostcall_t data;
	UInt32 r;
	data.a = ByteSwap32((UInt32)portId);
	data.b = ByteSwap32((UInt32)rcvBufP);
	data.c = ByteSwap32((UInt32)count);
	data.d = ByteSwap32((UInt32)timeout);
	data.e = ByteSwap32((UInt32)errP);
	arg[0] = BRIDGE_SrmReceive;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	r = my_call68KFuncP ( my_emulStateP,(UInt32)host_keyboard_handler, &(arg[0]), 8 );
	*errP = ByteSwap16((UInt16)(*errP));
	return r;
}

Err stub_SrmReceiveCheck(UInt16 portId, UInt32 *numBytesP)
{
	UInt32 arg[2];
	hostcall_t data;
	Err r;
	data.a = ByteSwap32((UInt32)portId);
	data.b = ByteSwap32((UInt32)numBytesP);
	arg[0] = BRIDGE_SrmReceiveCheck;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	r = my_call68KFuncP ( my_emulStateP,(UInt32)host_keyboard_handler, &(arg[0]), 8 );
	*numBytesP = ByteSwap32((UInt32)(*numBytesP));
	return r;
}

UInt32 stubtreokeys(UInt32 treokeys[3])
{
	UInt32 arg[2];
	hostcall_t data;

	data.a = data.b = data.c = 0;
	arg[0] = BRIDGE_TreoKey;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	my_call68KFuncP ( my_emulStateP, (UInt32)host_keyboard_handler, &arg, 8 );
	treokeys[0] = ByteSwap32(data.a);
	treokeys[1] = ByteSwap32(data.b);
	treokeys[2] = ByteSwap32(data.c);
	return (data.a | data.b | data.c);
}



UInt32 HandleBTGamepad()
{
	static UInt32 keyval = 0;

	if (g_bt_gamepadused)
	{
		UInt8 bytes[16];
		UInt32 check = 0;
		int i;
		Err err;
//		Char temp[256];
//		int idx;
		
		UInt32 arrKeysOpen[16] = {0, KEY_SEL, KEY_DOWN, KEY_RIGHT, KEY_LEFT, KEY_UP, KEY_QUICKSAVE, KEY_QUICKLOAD, KEY_SELECT, KEY_A, KEY_B, KEY_START, 0, 0, 0, 0};
		UInt32 arrKeysClosed[16] = {0, KEY_SEL, KEY_RIGHT, KEY_UP, KEY_DOWN, KEY_LEFT, KEY_QUICKSAVE, KEY_QUICKLOAD, KEY_SELECT, KEY_A, KEY_B, KEY_START, 0, 0, 0, 0};

		err = stub_SrmReceiveCheck(g_n_serportid, &check);
		if (err == serErrLineErr)
			SrmClearErr(g_n_serportid);
		if (check > 0)
		{
			UInt16 count = stub_SrmReceive(g_n_serportid, bytes, (check > 16) ? 16 : check, 0, &err);
//			idx = 0;
//			temp[idx] = 0;
			for (i=0; i<count; i++)
			{
				if ((bytes[i] & 0xf0) == 0x00)
				{
					if (g_bt_gamepadclosed)
						keyval &= ~arrKeysClosed[bytes[i] & 0x0f];
					else
						keyval &= ~arrKeysOpen[bytes[i] & 0x0f];
				}
				else if ((bytes[i] & 0xf0) == 0x40)
				{
//					temp[idx++] = '0' + (bytes[i] & 0x0f);
//					temp[idx++] = 0;
					if (g_bt_gamepadclosed)
						keyval |= arrKeysClosed[bytes[i] & 0x0f];
					else
						keyval |= arrKeysOpen[bytes[i] & 0x0f];
				}
			}
//			Sys_PrintF("%s %lx", temp, keyval);
		}
	}
	
	return keyval;
}

ircodelistType ircodelisttargus[]=
{
	{ 0x1e, 'A', 0},
	{ 0x30, 'B', 0},
	{ 0x2e, 'C', 0},
	{ 0x20, 'D', 0},
	{ 0x12, 'E', 0},
	{ 0x21, 'F', 0},
	{ 0x22, 'G', 0},
	{ 0x23, 'H', 0},
	{ 0x17, 'I', 0},
	{ 0x24, 'J', 0},
	{ 0x25, 'K', 0},
	{ 0x26, 'L', 0},
	{ 0x32, 'M', 0},
	{ 0x31, 'N', 0},
	{ 0x18, 'O', 0},
	{ 0x19, 'P', 0},
	{ 0x10, 'Q', 0},
	{ 0x13, 'R', 0},
	{ 0x1f, 'S', 0},
	{ 0x14, 'T', 0},
	{ 0x16, 'U', 0},
	{ 0x2f, 'V', 0},
	{ 0x11, 'W', 0},
	{ 0x2d, 'X', 0},
	{ 0x15, 'Y', 0},
	{ 0x2c, 'Z', 0},
	{ 0x02, '1', 0},
	{ 0x03, '2', 0},
	{ 0x04, '3', 0},
	{ 0x05, '4', 0},
	{ 0x06, '5', 0},
	{ 0x07, '6', 0},
	{ 0x08, '7', 0},
	{ 0x09, '8', 0},
	{ 0x0a, '9', 0},
	{ 0x0b, '0', 0},
	{ 0x01, vchrLaunch, 0},//ESC
	{ 0x0f, chrTab, 0},//TAB
	{ 0x1c, vchrRockerCenter, 0},//ENTER
	{ 0x39, vchrHard3, 0},//SPACE
	{ 0x4b, vchrRockerLeft, 0},
	{ 0x4d, vchrRockerRight, 0},
	{ 0x48, vchrRockerUp, 0},
	{ 0x50, vchrRockerDown, 0},
	{ 0x2a, vchrHard4, 0},//LSHIFT
	{ 0x1d, vchrHard1, 0},//LCTRL
	{ 0x38, vchrHard2, 0},//ALT

	{0,0,0}//end of list
};

ircodelistType ircodelistpalm[]=
{
	{ 0x1c, 'A', 0},
	{ 0x32, 'B', 0},
	{ 0x21, 'C', 0},
	{ 0x23, 'D', 0},
	{ 0x24, 'E', 0},
	{ 0x2b, 'F', 0},
	{ 0x34, 'G', 0},
	{ 0x33, 'H', 0},
	{ 0x43, 'I', 0},
	{ 0x3b, 'J', 0},
	{ 0x42, 'K', 0},
	{ 0x4b, 'L', 0},
	{ 0x3a, 'M', 0},
	{ 0x31, 'N', 0},
	{ 0x44, 'O', 0},
	{ 0x4d, 'P', 0},
	{ 0x24, 'Q', 0},
	{ 0x2d, 'R', 0},
	{ 0x1b, 'S', 0},
	{ 0x2c, 'T', 0},
	{ 0x3c, 'U', 0},
	{ 0x2a, 'V', 0},
	{ 0x1d, 'W', 0},
	{ 0x22, 'X', 0},
	{ 0x35, 'Y', 0},
	{ 0x1a, 'Z', 0},
	{ 0x16, '1', 0},
	{ 0x1e, '2', 0},
	{ 0x26, '3', 0},
	{ 0x25, '4', 0},
	{ 0x2e, '5', 0},
	{ 0x36, '6', 0},
	{ 0x3d, '7', 0},
	{ 0x3e, '8', 0},
	{ 0x46, '9', 0},
	{ 0x45, '0', 0},
	{ 0x0e, vchrLaunch, 0},//ESC
	{ 0x0d, chrTab, 0},//TAB
	{ 0x5a, vchrRockerCenter, 0},//ENTER
	{ 0x29, vchrHard3, 0},//SPACE
	{ 0x5e, vchrRockerLeft, 0},
	{ 0x2f, vchrRockerRight, 0},
	{ 0x28, vchrRockerUp, 0},
	{ 0x60, vchrRockerDown, 0},
	{ 0x12, vchrHard4, 0},//LSHIFT
	{ 0x14, vchrHard1, 0},//LCTRL
	{ 0x03, vchrHard2, 0},//ALT

	{0,0,0}//end of list
};

ircodelistType ircodeliststow[]=
{
	{ 0x11, 'A', 0},
	{ 0x2e, 'B', 0},
	{ 0x2c, 'C', 0},
	{ 0x13, 'D', 0},
	{ 0x0b, 'E', 0},
	{ 0x14, 'F', 0},
	{ 0x15, 'G', 0},
	{ 0x16, 'H', 0},
	{ 0x3d, 'I', 0},
	{ 0x44, 'J', 0},
	{ 0x45, 'K', 0},
	{ 0x46, 'L', 0},
	{ 0x4c, 'M', 0},
	{ 0x2f, 'N', 0},
	{ 0x3e, 'O', 0},
	{ 0x3f, 'P', 0},
	{ 0x09, 'Q', 0},
	{ 0x0c, 'R', 0},
	{ 0x12, 'S', 0},
	{ 0x0d, 'T', 0},
	{ 0x3c, 'U', 0},
	{ 0x2d, 'V', 0},
	{ 0x0a, 'W', 0},
	{ 0x10, 'X', 0},
	{ 0x0e, 'Y', 0},
	{ 0x03, 'Z', 0},
	{ 0x09, '1', 0},
	{ 0x0a, '2', 0},
	{ 0x0b, '3', 0},
	{ 0x0c, '4', 0},
	{ 0x0d, '5', 0},
	{ 0x0e, '6', 0},
	{ 0x3c, '7', 0},
	{ 0x3d, '8', 0},
	{ 0x3e, '9', 0},
	{ 0x3f, '0', 0},
	{ 0x32, vchrLaunch, 0},//ESC
	{ 0x19, chrTab, 0},//TAB
	{ 0x41, vchrRockerCenter, 0},//ENTER
	{ 0x17, vchrHard3, 0},//SPACE
	{ 0x51, vchrRockerLeft, 0},
	{ 0x53, vchrRockerRight, 0},
	{ 0x48, vchrRockerUp, 0},
	{ 0x52, vchrRockerDown, 0},
	{ 0x58, vchrHard4, 0},//LSHIFT
	{ 0x1a, vchrHard1, 0},//LCTRL
	{ 0x23, vchrHard2, 0},//ALT

	{0,0,0}//end of list
};

ircodelistType ircodeliststowazerty[]=
{
	{ 0x09, 'A', 0},
	{ 0x2e, 'B', 0},
	{ 0x2c, 'C', 0},
	{ 0x13, 'D', 0},
	{ 0x0b, 'E', 0},
	{ 0x14, 'F', 0},
	{ 0x15, 'G', 0},
	{ 0x16, 'H', 0},
	{ 0x3b, 'I', 0},
	{ 0x44, 'J', 0},
	{ 0x45, 'K', 0},
	{ 0x46, 'L', 0},
	{ 0x47, 'M', 0},
	{ 0x2f, 'N', 0},
	{ 0x3e, 'O', 0},
	{ 0x3f, 'P', 0},
	{ 0x11, 'Q', 0},
	{ 0x0c, 'R', 0},
	{ 0x12, 'S', 0},
	{ 0x0d, 'T', 0},
	{ 0x3c, 'U', 0},
	{ 0x2d, 'V', 0},
	{ 0x03, 'W', 0},
	{ 0x10, 'X', 0},
	{ 0x0e, 'Y', 0},
	{ 0x0a, 'Z', 0},
	{ 0x09, '1', 0},
	{ 0x0a, '2', 0},
	{ 0x0b, '3', 0},
	{ 0x0c, '4', 0},
	{ 0x0d, '5', 0},
	{ 0x0e, '6', 0},
	{ 0x3c, '7', 0},
	{ 0x3d, '8', 0},
	{ 0x3e, '9', 0},
	{ 0x3f, '0', 0},
	{ 0x32, vchrLaunch, 0},//ESC
	{ 0x19, chrTab, 0},//TAB
	{ 0x41, vchrRockerCenter, 0},//ENTER
	{ 0x17, vchrHard3, 0},//SPACE
	{ 0x51, vchrRockerLeft, 0},
	{ 0x53, vchrRockerRight, 0},
	{ 0x48, vchrRockerUp, 0},
	{ 0x52, vchrRockerDown, 0},
	{ 0x58, vchrHard4, 0},//LSHIFT
	{ 0x1a, vchrHard1, 0},//LCTRL
	{ 0x23, vchrHard2, 0},//ALT

	{0,0,0}//end of list
};

ircodelistType *ircodelist;

HandleIRkeyboard_targus()
{
	static UInt32 keyval = 0;

	if (g_ir_keyboardused)
	{
		UInt8 bytes[6]; // one frame is 6 bytes
		UInt32 check = 0;
		int i,j;
		Err err;

		err = stub_SrmReceiveCheck(g_n_serportid, &check);
		if (err == serErrLineErr)
			SrmClearErr(g_n_serportid);
		while (check > 0)
		{
			// pick up max 1 frame
			UInt16 count = stub_SrmReceive(g_n_serportid, bytes, (check > 6) ? 6 : check, 0, &err);
			for (i=0; i<count; i++)
			{
				
				
				j=0;
				while(ircodelist[j].irkeycode)
				{
					if (ircodelist[j].irkeycode == bytes[i])
					{
							ircodelist[j].pressed = 1;
						/*{
							char temp[40];
							sprintf(temp,"%02x %i", bytes[i], ircodelist[j].pressed);
							osd_display_message_nowait(temp);
						}*/
					}
					else if (ircodelist[j].irkeycode + 0x80 == bytes[i])
					{
							ircodelist[j].pressed = 0;
							
						/*{
							char temp[40];
							sprintf(temp,"%02x %i", bytes[i], ircodelist[j].pressed);
							osd_display_message_nowait(temp);
						}*/
					}
					j++;
				}
				//DEBUG ONLY
				/*if (bytes[i])
				{
					char temp[40];
					sprintf(temp,"%02x", bytes[i]);
					osd_display_message_nowait(temp);
				}*/
				
			}
			stub_SrmReceiveCheck(g_n_serportid, &check);
		}
	}
	
	return keyval;
}
HandleIRkeyboard_palm()
{
	static UInt32 keyval = 0;

	if (g_ir_keyboardused)
	{
		UInt8 bytes[6]; // one frame is 6 bytes
		UInt32 check = 0;
		int i,j;
		Err err;

		err = stub_SrmReceiveCheck(g_n_serportid, &check);
		if (err == serErrLineErr)
			SrmClearErr(g_n_serportid);
		while (check > 0)
		{
			// pick up max 1 frame
			UInt16 count = stub_SrmReceive(g_n_serportid, bytes, (check > 6) ? 6 : check, 0, &err);
			for (i=0; i<count; i++)
			{

		
				// look out for the beginning of a frame
				if (bytes[i] != 0xff)
					continue;
				i++;
				if (i >= count)
				{
					count = stub_SrmReceive(g_n_serportid, bytes, 5, 0, &err);
					if (count == 0)
						break;
					i = 0;
				}
				if (bytes[i] != 0xc0)
					continue;
				i++;
				if (i >= count)
				{
					count = stub_SrmReceive(g_n_serportid, bytes, 4, 0, &err);
					if (count == 0)
						break;
					i = 0;
				}
				
/*if (bytes[i])
{
	char temp[40];
	sprintf(temp,"IR: 0x%02x", bytes[i]);
	osd_display_message_nowait(temp);
}*/
				j=0;
				while(ircodelist[j].irkeycode)
				{
					if (ircodelist[j].irkeycode == bytes[i])
					{
							ircodelist[j].pressed = 1;
						/*{
							char temp[40];
							sprintf(temp,"%02x %i", bytes[i], ircodelist[j].pressed);
							osd_display_message_nowait(temp);
						}*/
					}
					else if (ircodelist[j].irkeycode + 0x80 == bytes[i])
					{
							ircodelist[j].pressed = 0;
							
						/*{
							char temp[40];
							sprintf(temp,"%02x %i", bytes[i], ircodelist[j].pressed);
							osd_display_message_nowait(temp);
						}*/
					}
					j++;
				}
				
				// that's it, skip crc and frame end
				i += 3;
			}
			stub_SrmReceiveCheck(g_n_serportid, &check);
		}
	}
	
	return keyval;
}




#define __STACK_SIZE__ 63*1024 

uint32 my_stack,my_stackal,old_stack;
  
asm uint32 swap_stack(uint32 new ,uint32 dummy)
{	
	mov  r1,r13
	mov  r13,r0
	mov	 r0,r1
	bx	 lr
}

// ------------------------
unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP)
{
	#if DEBUG
	AdnDebugNativeRegister('appl', appFileCreator, 'ARMC', 1);
	#endif
	

	my_emulStateP = (void *)emulStateP;
	my_call68KFuncP = call68KFuncP;

	
	// needed before making any OS calls using the 
	// PACEInterface library
	//InitPACEInterface(emulStateP, call68KFuncP);
	
	twGlue = (struct TwGlue*) userData68KP;
	//We only want TW functions
	//if (!twGlue)
	//	TwUndef();

	//FrmCustomAlert(10024,"PNO_MAIN","","");

	FtrGet(appFileCreator,1112,&host_event_handler);
	FtrGet(appFileCreator,1116,&host_keyboard_handler);

	//osd_display_message("app_start_start");

	/*new stack*/
  	my_stack=(uint32)MemPtrNew(__STACK_SIZE__+8);
  	my_stackal=my_stack+__STACK_SIZE__;
  	my_stackal-=my_stackal&7;

  	old_stack=swap_stack(my_stackal,0);
  	
#if MEMORY_DEBUG
  	malloc_debug_init();
#endif

	UInt32 *ftrptr;
	/*FtrGet(appFileCreator, FTR_OPT_INPUTCONF_TREO_ID, (unsigned long*) &ftrptr);
	for (int i=0; i<20; i++)
	{
		for (int j=0; j<3; j++)
		{
			g_confinput_treo[i][j] = ByteSwap32(ftrptr[i * 3 + j]);
		}
	}*/
	//FtrGet(appFileCreator, FTR_OPT_BTGP_USED_ID, &g_bt_gamepadused);
	//FtrGet(appFileCreator, FTR_OPT_BTGP_CLOSED_ID, &g_bt_gamepadclosed);
	FtrGet(appFileCreator, FTR_OPT_SERIAL_PORTID_ID, &g_n_serportid);
	FtrGet(appFileCreator, FTR_OPT_IRKB_USED_ID, &g_ir_keyboardused);
	//FtrGet(appFileCreator, FTR_OPT_IRKB_CONFIG_ID, (unsigned long*)&ftrptr);
	//for (int i=0; i<128; i++) g_ir_confinput[i] = ((UInt8 *) ftrptr)[i];

	if (g_ir_keyboardused == 1)
	{
		irhandler = &HandleIRkeyboard_targus;
		ircodelist = ircodelisttargus;
	}
	else if (g_ir_keyboardused == 2)
	{
		irhandler = &HandleIRkeyboard_palm;
		ircodelist = ircodelistpalm;
	}
	else if (g_ir_keyboardused == 3)
	{
		irhandler = &HandleIRkeyboard_palm;
		ircodelist = ircodeliststow;
	}
	else if (g_ir_keyboardused == 4)
	{
		irhandler = &HandleIRkeyboard_palm;
		ircodelist = ircodeliststowazerty;
	}

	MameAppStart();
	MameAppStop();

#if MEMORY_DEBUG
	malloc_debug_status(1);
#endif

  	swap_stack(old_stack,0);
  	MemPtrFree((void*)my_stack);

	return errNone;
}
