/***************************************************************************

    M.A.M.E.CE3  -  Multiple Arcade Machine Emulator for Pocket PC
    Win32 Portions Copyright (C) 1997-98 Michael Soderstrom and Chris Kirmse
    
    This file is part of MAMECE3, and may only be used, modified and
    distributed under the terms of the MAME license, in "MAME.txt".
    By continuing to use, modify or distribute this file you indicate
    that you have read the license and understand and accept it fully.

 ***************************************************************************/


#ifndef mamePALM_H
#define mamePALM_H


#include "file.h"
#include "osdepend.h"
#include "driver.h"
#include <IRlib.h>

#define MENU_HEIGHT 26


// User Defined Funtion Prototypes
#ifdef __cplusplus
extern "C" {
#endif

TCHAR *WC(const char *str);
TCHAR *WC2(const char *str);
//extern void MamePlayGame(int index, struct ui_options* UI);
extern void set_root_path(void);

#ifdef __cplusplus
}
#endif

// our dialog/configured options //
struct ui_options
{
	BOOL		enable_sound;		// Enable sound in games
	BOOL		show_all_games;		// Should we show all games?
	BOOL		show_clones;		// Don't show clone games
	BOOL		show_framerate;		// Display Frame Rate
	BOOL		show_profiler;		// Display the profiler
	BOOL		enable_flicker;		// Enable Flicker
	BOOL		enable_translucency;// Enable Translucency
	BOOL		enable_antialias;	// Enable AntiAlias
	BOOL		enable_dirtyline;	// Enable Dirty Line Drawing
	BOOL		disable_throttle;	// Disable Throttling
	BOOL		rotate_left;		// Rotate the Screen to the Left
	BOOL		rotate_right;		// Rotate the Screen to the Right
	int			DevID;				// Device-Manufacturer ID
};

typedef struct
{
    BOOL has_roms;
    BOOL has_samples;
    BOOL is_neogeo_clone;
} status_of_data;

#endif // !defined(AFX_MAMECE3_H__83E92306_FA0D_11D4_B50D_00105A5DC740__INCLUDED_)
