#ifndef C68000_H
#define C68000_H
#include "Cyclone.h"

typedef struct
{
	struct Cyclone regs;
	int pending_interrupts;
} Cyclone_Regs;

/*enum {
	M68K_PC=1, M68K_ISP, M68K_USP, M68K_SR, M68K_VBR, M68K_SFC, M68K_DFC,
	M68K_D0, M68K_D1, M68K_D2, M68K_D3, M68K_D4, M68K_D5, M68K_D6, M68K_D7,
	M68K_A0, M68K_A1, M68K_A2, M68K_A3, M68K_A4, M68K_A5, M68K_A6, M68K_A7 };*/

extern void cyclone_Reset(void);                      
extern int  cyclone_Execute(int);                     
extern void cyclone_SetRegs(Cyclone_Regs *);          
unsigned cyclone_GetRegs(Cyclone_Regs *dst);
extern void cyclone_Cause_Interrupt(int);             
extern void cyclone_Clear_Pending_Interrupts(void);   
extern int  cyclone_GetPC(void);                      

extern int cyclone_ICount;                            

#define cyclone_INT_NONE 0							  
#define cyclone_IRQ_1    1
#define cyclone_IRQ_2    2
#define cyclone_IRQ_3    3
#define cyclone_IRQ_4    4
#define cyclone_IRQ_5    5
#define cyclone_IRQ_6    6
#define cyclone_IRQ_7    7

#define cyclone_INT_ACK_AUTOVECTOR    -1

#define cyclone_STOP     0x10

#define MC68000_INT_NONE 0							  
#define MC68000_IRQ_1    1
#define MC68000_IRQ_2    2
#define MC68000_IRQ_3    3
#define MC68000_IRQ_4    4
#define MC68000_IRQ_5    5
#define MC68000_IRQ_6    6
#define MC68000_IRQ_7    7

#define MC68000_INT_ACK_AUTOVECTOR    -1

#define MC68000_STOP     0x10


//AK - MAME defines for ease of upgrade
#define cyclone_reset cyclone_Reset
#define cyclone_execute cyclone_Execute
#define cyclone_get_context cyclone_GetRegs
#define cyclone_set_context cyclone_SetRegs
#define cyclone_get_pc cyclone_GetPC
#define cyclone_ICount cyclone_ICount

extern void cyclone_exit(void);
extern void cyclone_set_pc(unsigned val);
extern unsigned cyclone_get_sp(void);
extern void cyclone_set_sp(unsigned val);
extern unsigned cyclone_get_reg(int regnum);
extern void cyclone_set_reg(int regnum, unsigned val);
extern void cyclone_set_nmi_line(int state);
extern void cyclone_set_irq_line(int irqline, int state);
extern void cyclone_set_irq_callback(void (*callback)(int irqline));
extern const char *cyclone_info(void *context, int regnum);
extern unsigned cyclone_dasm(char *buffer, unsigned pc);


#endif
